const pBranch = Components.interfaces.nsIPrefBranch;
var gPref = Components.classes["@mozilla.org/preferences-service;1"].getService(pBranch);

function settingsInit() {
  document.getElementById("enableOfficeXPToolbars").checked = gPref.getBoolPref("extensions.cutemenus.enableOfficeXPToolbars");
  document.getElementById("enableMenuInfoTooltip").checked = gPref.getBoolPref("extensions.cutemenus.enableMenuInfoTooltip");
  document.getElementById("enableOfficeXPDividers").checked = gPref.getBoolPref("extensions.cutemenus.enableOfficeXPDividers");
  document.getElementById("enableToolsConfig").checked = gPref.getBoolPref("extensions.cutemenus.enableToolsConfig");
  document.getElementById("enableNoGo").checked = gPref.getBoolPref("extensions.cutemenus.enableNoGo");
  document.getElementById("enableNoSearch").checked = gPref.getBoolPref("extensions.cutemenus.enableNoSearch");
  document.getElementById("enableIcons").checked = gPref.getBoolPref("extensions.cutemenus.enableIcons");
  document.getElementById("enableDisabledIcons").checked = gPref.getBoolPref("extensions.cutemenus.enableDisabledIcons");
  document.getElementById("enableCheck").checked = gPref.getBoolPref("extensions.cutemenus.enableCheck");
  document.getElementById("enableRadio").checked = gPref.getBoolPref("extensions.cutemenus.enableRadio");
  document.getElementById("enableOfficeXPActive").checked = gPref.getBoolPref("extensions.cutemenus.enableOfficeXPActive");
  var enableFlatStyleStandard = gPref.getBoolPref("extensions.cutemenus.enableFlatStyleStandard");
  var enableFlatStyleXP = gPref.getBoolPref("extensions.cutemenus.enableFlatStyleXP");

  if (enableFlatStyleStandard || enableFlatStyleXP) {
    if (enableFlatStyleStandard) {
      document.getElementById("flatStyleMenuType").selectedIndex = 0;
    } else {
      document.getElementById("flatStyleMenuType").selectedIndex = 1;
    }
    document.getElementById("enableOfficeXPStyle").setAttribute("checked", true);
  } else {
    document.getElementById("enableOfficeXPStyle").setAttribute("checked", false);
  }

  var enableMenubarIconsWithText = gPref.getBoolPref("extensions.cutemenus.enableMenubarIconsWithText");
  var enableMenubarIcons = gPref.getBoolPref("extensions.cutemenus.enableMenubarIcons");

  if (enableMenubarIconsWithText || enableMenubarIcons) {
    if (enableMenubarIconsWithText) {
      document.getElementById("MenubarIconHack").selectedIndex = 0;
    } else {
      document.getElementById("MenubarIconHack").selectedIndex = 1;
    }
    document.getElementById("enableMenubarIconsCheckbox").setAttribute("checked", true);
  } else {
    document.getElementById("enableMenubarIconsCheckbox").setAttribute("checked", false);
  }

  enableOfficeXPStyleChanged();
  enableMenubarIconsHackChanged();
  enableIconsChanged();

  // Check the parameter
  var showAboutParameter = window.location.search.substr("?showAbout=".length, window.location.search.length);
  if ((showAboutParameter == "true") || (showAboutParameter == "yes")) {
    document.getElementById("settingsTabBox").selectedTab = document.getElementById("aboutTab");
  }
}

function saveSettings() {
  gPref.setBoolPref("extensions.cutemenus.enableOfficeXPToolbars", document.getElementById("enableOfficeXPToolbars").checked);
  gPref.setBoolPref("extensions.cutemenus.enableOfficeXPDividers", document.getElementById("enableOfficeXPDividers").checked);
  gPref.setBoolPref("extensions.cutemenus.enableMenuInfoTooltip", document.getElementById("enableMenuInfoTooltip").checked);
  gPref.setBoolPref("extensions.cutemenus.enableToolsConfig", document.getElementById("enableToolsConfig").checked);
  gPref.setBoolPref("extensions.cutemenus.enableNoGo", document.getElementById("enableNoGo").checked);
  gPref.setBoolPref("extensions.cutemenus.enableNoSearch", document.getElementById("enableNoSearch").checked);
  gPref.setBoolPref("extensions.cutemenus.enableIcons", document.getElementById("enableIcons").checked);
  gPref.setBoolPref("extensions.cutemenus.enableDisabledIcons", document.getElementById("enableDisabledIcons").checked);
  gPref.setBoolPref("extensions.cutemenus.enableCheck", document.getElementById("enableCheck").checked);
  gPref.setBoolPref("extensions.cutemenus.enableRadio", document.getElementById("enableRadio").checked);
  gPref.setBoolPref("extensions.cutemenus.enableOfficeXPActive", document.getElementById("enableOfficeXPActive").checked);
  if (document.getElementById("enableOfficeXPStyle").checked) {
    if (document.getElementById("flatStyleMenuType").selectedIndex == 0) {
      gPref.setBoolPref("extensions.cutemenus.enableFlatStyleStandard", true);
      gPref.setBoolPref("extensions.cutemenus.enableFlatStyleXP", false);
    } else {
      gPref.setBoolPref("extensions.cutemenus.enableFlatStyleStandard", false);
      gPref.setBoolPref("extensions.cutemenus.enableFlatStyleXP", true);
    }
  } else {
    gPref.setBoolPref("extensions.cutemenus.enableFlatStyleStandard", false);
    gPref.setBoolPref("extensions.cutemenus.enableFlatStyleXP", false);
  }

  if (document.getElementById("enableMenubarIconsCheckbox").checked) {
    if (document.getElementById("MenubarIconHack").selectedIndex == 0) {
      gPref.setBoolPref("extensions.cutemenus.enableMenubarIconsWithText", true);
      gPref.setBoolPref("extensions.cutemenus.enableMenubarIcons", false);
    } else {
      gPref.setBoolPref("extensions.cutemenus.enableMenubarIconsWithText", false);
      gPref.setBoolPref("extensions.cutemenus.enableMenubarIcons", true);
    }
  } else {
    gPref.setBoolPref("extensions.cutemenus.enableMenubarIconsWithText", false);
    gPref.setBoolPref("extensions.cutemenus.enableMenubarIcons", false);
  }
}

function enableOfficeXPStyleChanged() {
  var enableOfficeXPStyleCheckbox = document.getElementById("enableOfficeXPStyle");
  document.getElementById("enableFlatStyleStandard").disabled = !enableOfficeXPStyleCheckbox.checked;
  document.getElementById("enableFlatStyleXP").disabled = !enableOfficeXPStyleCheckbox.checked;
}

function enableMenubarIconsHackChanged() {
  var enableMenubarIconsCheckbox = document.getElementById("enableMenubarIconsCheckbox");
  document.getElementById("enableMenubarIconsWithText").disabled = !enableMenubarIconsCheckbox.checked;
  document.getElementById("enableMenubarIcons").disabled = !enableMenubarIconsCheckbox.checked;
}

function enableIconsChanged() {
  var enableIconsCheckbox = document.getElementById("enableIcons");
  document.getElementById("enableDisabledIcons").disabled = !enableIconsCheckbox.checked;
}
